local eventFrame = CreateFrame("Frame");
local PitBull_HealthBar = PitBull:GetModule("HealthBar");
local QuickHealth = LibStub("LibQuickHealth-1.0");
local _G = getfenv(0);

-- env changement code taken from interruptus
local proxyEnv = {
	UnitHealth = function(...) return QuickHealth.UnitHealth(QuickHealth, ...); end,
}

setmetatable(proxyEnv, { 
	__index    = _G,
	__newindex = function (t, k, v) _G[k] = v end,
})

local oldEnvUpdateHealth;
local oldEnvUpdateHealthBarColor;
--- On the PLAYER_LOGIN event we register the HealthUpdated callback from QuickHealth, when it happens, we loop through all frames and call UpdateHealth on the ones with the currect GUID
eventFrame:SetScript("OnEvent", function(self)
	oldEnvUpdateHealth = getfenv(PitBull_HealthBar.UpdateHealth);
	oldEnvUpdateHealthBarColor = getfenv(PitBull_HealthBar.UpdateHealthbarColor);
	QuickHealth.RegisterCallback(self, "HealthUpdated", function(event, GUID, newHealth)
		setfenv(PitBull_HealthBar.UpdateHealth, proxyEnv);
		setfenv(PitBull_HealthBar.UpdateHealthbarColor, proxyEnv);
		for unit, frame in PitBull:IterateUnitFrames() do
			local frameGUID = UnitGUID(unit);
			if(frameGUID == GUID) then
				PitBull_HealthBar:UpdateHealth(unit, frame);
				PitBull_HealthBar:UpdateHealthbarColor(unit, frame);
			end
		end
		setfenv(PitBull_HealthBar.UpdateHealth, oldEnvUpdateHealth);
		setfenv(PitBull_HealthBar.UpdateHealthbarColor, oldEnvUpdateHealthBarColor);
	end);
end);

eventFrame:RegisterEvent("PLAYER_LOGIN");